%{

%}

%token <int> NUM
%token TRUE FALSE
%token <string> ID
%token INT PLUS MINUS STAR SLASH EQUAL EQUALEQUAL LE LT GE GT NOT AND OR IF THEN
    READ ELSE WHILE DO READ PRINT SEMICOLON LET IN COMMA ISZERO LETPROC NEWREF DEREF
SETREF BEGIN END
%token LBRACE RBRACE LBLOCK RBLOCK LPAREN RPAREN EOF

%left SEMICOLON
%left OR
%left AND
%left LT LE GT GE EQUALEQUAL
%left PLUS MINUS
%left STAR SLASH 
%right NOT 


%start program
%type <M.program> program
%%

program:
    exp EOF { $1 }
    ;

exp:
    NUM { M.CONST $1 }
  | ID { M.VAR $1 }
  | READ { M.READ }
  | exp PLUS exp  { M.ADD ($1,$3) }
  | exp MINUS exp { M.SUB ($1,$3) }
  | ISZERO exp { M.ISZERO $2 }
  | IF exp THEN exp ELSE exp { M.IF ($2,$4,$6) }
  | LET ID EQUAL exp IN exp { M.LET ($2,$4,$6) }
  | LPAREN exp RPAREN { $2 }
%%

let parse_error s = print_endline s
